// **********************************************************************
//
// Copyright (c) 2003
// Integrated Solutions Technology, Philippines
//
// All Rights Reserved.
//
// $Id: JLibSink.cpp,v 1.1 2003/12/23 20:21:34 amrufon Exp $
// **********************************************************************

#include "stdafx.h"
#include <Ice/Ice.h>
#include <Ice/Stats.h>
#include <JLibSinkI.h>

using namespace std;

class JLibSinkStats : public virtual Ice::Stats {
public:
	virtual void bytesSent (const std::string &prot, Ice::Int num)
	{
		cout << prot << ": sent " << num << " bytes" << endl;
	};

	virtual void bytesReceived(const std::string &prot, Ice::Int num)
	{
		cout << prot << ": received " << num << " bytes" << endl;
	};
};

class JLibSink : virtual public Ice::Application {
public:
	virtual int run(int argc, char* argv[]) {
		// Server code
		Ice::ObjectAdapterPtr adapter = 
			communicator()->createObjectAdapterWithEndpoints(
				"JLibAdapter", "default -p 7012 -z");
		Ice::ObjectPtr object = new JlibSinkI;
		adapter->add(object,
			Ice::stringToIdentity("JLib"));
		adapter->activate();
		
		// Lets activate the status class too
		Ice::StatsPtr stats = new JLibSinkStats;
		communicator()->setStats(stats);

		// Wait until all operations are completed
		communicator()->waitForShutdown();
		if (interrupted()) {
			cerr << appName() 
				<< ": received signal, shutting down" << endl;
		}
		return 0;
	};
};

int main(int argc, char* argv[]) {
	JLibSink app;
	return app.main(argc,argv);
}
